<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/search.2.php";
include_once "include/site.php";
include_once "$theme/theme.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

/* this will enable administrators to empty anybody's trash */
if ($po_user['type'] == $user_type['administrator']) {
   $user_id = $_REQUEST['user'];
 } else {
  $user_id = $po_user['id'];
}

$destination_basket = $_REQUEST['basket'];
$destination_folder = $_REQUEST['destination_folder'];
$destination_album  = $_REQUEST['destination_album'];
$source_folder      = $_REQUEST['source_folder'];
$source_album       = $_REQUEST['source_album'];
$source_photo       = $_REQUEST['source_photo'];
$goto_folder        = $_REQUEST['goto_folder'];
$print_type         = $_REQUEST['print_type'];
$export_type        = $_REQUEST['export_type'];

$order_by           = $_REQUEST['order_by'];
$return_path        = $_REQUEST['return'];

$access_rights    = $_REQUEST['access_rights'];

if ($order_by) {
  $return_path = $return_path . "&order_by=$order_by";
}

if ($destination_folder == "" &&
    $destination_album == "" &&
    $print_type == "" &&
    $export_type == "" &&
    $goto_folder == "" &&
    $destination_basket == "" &&
    $access_rights == "") {
  site_epilog($database);
  header("location: $return_path");
  exit();
}

if ($goto_folder != "") {
  header("location: folder.php?folder=$goto_folder");
  exit();
}

if ($destination_basket == "yes" && $destination_album == "") {
  $user_id = $_REQUEST['user'];
  $num_of_photos = $_REQUEST['num_of_checkboxes'];
  for ($counter = 0; $counter < $num_of_photos; $counter++) {
    $photo_identifier = $_REQUEST['cb'.$counter];
    if ($photo_identifier) {
      /* this is quick and dirty but we avoid using plpgsql */
      $num_of_items = pg_fetch_row(pg_query($database, "
        select count(identifier)
          from shop_order
         where item=(select min(identifier) from photo_item where photo=$photo_identifier)
           and transaction = null
           and client=$po_user[id]"));

      if ($num_of_items[0] == 0) {
        pg_query($database, "
          insert into shop_order (identifier, client, transaction, pieces, date_of_creation, date_of_last_edit, item)
          values (nextval('shop_order_id_sequence'), $po_user[id], null, 1, now(), now(), (select min(identifier) from photo_item where photo=$photo_identifier))");
      }
    }
  }
  site_epilog($database);
  header("location: $return_path");
  exit();
}

if ($export_type != "") {
  pg_query($database, "delete from photo_spooler where users=$user_id");
  $photos_in_spooler = 0;

  $num_of_photos = $_REQUEST['num_of_checkboxes'];
  for ($counter = 0; $counter < $num_of_photos; $counter++) {
    $photo_identifier = $_REQUEST['cb'.$counter];
      
    if ($photo_identifier) {
      if ($po_user['type'] < $user_type['administrator']) {
	/* Ensure mere users don't move/mangle a photo that isn't theirs! */
	$result = pg_query($database, "select identifier from photo where identifier='$photo_identifier' and users = $po_user[id]");
	if (pg_num_rows($result) <= 0) {
	  site_epilog($database);
	  header("location: login.php?reason=1");
	  exit();
	}
      }
      
      $photos_in_spooler++;
      pg_query($database, "insert into photo_spooler (identifier, users, photo)
                           values (nextval('photo_spooler_id_sequence'), $user_id, $photo_identifier)");
    }
  }
  site_epilog($database);

  if ($photos_in_spooler == 0) {
    header("location: $return_path");
    exit();
  }

  $arguments = "export_type=$export_type";
  if ($source_folder != "")
    $arguments = $arguments . "&source_folder=$source_folder";
  if ($source_album != "")
    $arguments = $arguments . "&source_album=$source_album";
  if ($source_photo != "")
    $arguments = $arguments . "&source_photo=$source_photo";
  header("location: export.php?$arguments");
  exit();
}

if ($print_type != "") {
  pg_query($database, "delete from photo_spooler where users=$user_id");
  $photos_in_spooler = 0;

  $num_of_photos = $_REQUEST['num_of_checkboxes'];
  for ($counter = 0; $counter < $num_of_photos; $counter++) {
    $photo_identifier = $_REQUEST['cb'.$counter];

    if ($photo_identifier) {

      if ($po_user['type'] < $user_type['administrator']) {
	/* Ensure mere users don't move/mangle a photo that isn't theirs! */
	$result = pg_query($database, "select identifier from photo where identifier='$photo_identifier' and users = $po_user[id]");
	if (pg_num_rows($result) <= 0) {
	  site_epilog($database);
	  header("location: login.php?reason=1");
	  exit();
	}
      }

      $photos_in_spooler++;
      pg_query($database, "insert into photo_spooler (identifier, users, photo)
                           values (nextval('photo_spooler_id_sequence'), $user_id, $photo_identifier)");
    }
  }

  /* check for photos in spooler */
  if ($photos_in_spooler == 0) {
    site_epilog($database);
    header("location: $return_path");
    exit();
  }

  $arguments = "print_type=$print_type";
  if ($source_folder != "")
    $arguments = $arguments . "&source_folder=$source_folder";
  if ($source_album != "")
    $arguments = $arguments . "&source_album=$source_album";
  if ($source_photo != "")
    $arguments = $arguments . "&source_photo=$source_photo";
  site_epilog($database);
  header("location: print.php?$arguments");
  exit();
}

if ($access_rights != "") {
  $num_of_photos = $_REQUEST['num_of_checkboxes'];
  for ($counter = 0; $counter < $num_of_photos; $counter++) {
    $photo_identifier = $_REQUEST['cb'.$counter];

    if ($photo_identifier) {
      if ($po_user['type'] < $user_type['administrator']) {
	/* Ensure mere users don't move/mangle a photo that isn't theirs! */
	$result = pg_query($database, "select identifier from photo where identifier='$photo_identifier' and users = $po_user[id]");
	if (pg_num_rows($result) <= 0) {
	  site_epilog($database);
	  header("location: login.php?reason=1");
	  exit();
	}
      }
      
      pg_query($database, "update photo set access_rights=$access_rights where identifier=$photo_identifier");
    }
  }
  header("location: $return_path");
  exit();
}

$trash_id = pg_fetch_row(pg_query($database, "select identifier from folder where caption='Trash' and users=$user_id"));
$orphanage_id = pg_fetch_row(pg_query($database, "select identifier from folder where caption='Orphanage' and users=$user_id"));

if ($po_user['type'] < $user_type['administrator']) {
  /* ...to an album that isn't theirs! */
  if ($destination_album != "" && $destination_album != "trash") {
    $result = pg_query($database, "select identifier from album where identifier='$destination_album' and users = $po_user[id]");
    if (pg_num_rows($result) <= 0) {
      site_epilog($database);
      header("location: login.php?reason=2");
      exit();
    }
  }

  /* ...to a folder that isn't theirs! */
  if ($destination_folder != "") {
    $result = pg_query($database, "select identifier from folder where identifier='$destination_folder' and users = $po_user[id]");
    if (pg_num_rows($result) <= 0) {
      site_epilog($database);
      header("location: login.php?reason=3");
      exit();
    }
  }
}


$num_of_photos = $_REQUEST['num_of_checkboxes'];
for ($counter = 0; $counter < $num_of_photos; $counter++) {
  $photo_identifier = $_REQUEST['cb'.$counter];

  if ($photo_identifier) {
    if ($po_user['type'] < $user_type['administrator']) {
      /* Ensure mere users don't move/mangle a photo that isn't theirs! */
      $result = pg_query($database, "select identifier from photo where identifier='$photo_identifier' and users = $po_user[id]");
      if (pg_num_rows($result) <= 0) {
	site_epilog($database);
	header("location: login.php?reason=1");
	exit();
      }
    }

    if ($destination_folder != "") {
      if ($destination_folder == $trash_id[0]) {
        /* do not remove photos that were involved in a shop transaction */
        /* instead move them into the Orphanage */
        $num_of_transactions = pg_fetch_row(pg_query($database, "select photo_shop_transaction_references($photo_identifier)"));
        if ($num_of_transactions[0] > 0) {
          pg_query($database, "update photo set folder=$orphanage_id[0] where identifier=$photo_identifier");
          continue;
        }
      }
      pg_query($database, "update photo set folder=$destination_folder where identifier=$photo_identifier");
      continue;
    }

    if ($destination_album != "") {
      if ($destination_album == "trash") {
        /* in case the same photo apperars twice in an album, */
        /* we do the min() hack to remove only one of them */
        pg_query($database, "delete from album_content where identifier=(select min(identifier) from album_content where photo=$photo_identifier)");
      } else {
        pg_query($database, "begin");
        if ($source_album != "") {
          $result = pg_query($database, "delete from album_content where album=$source_album and identifier=(select min(identifier) from album_content where photo=$photo_identifier)");
          if (!$result) {
            pg_query($database, "rollback");
            continue;
          }
        }
        $result = pg_query($database, "insert into album_content (identifier, photo, album)
                             values (nextval('album_content_id_sequence'), $photo_identifier, $destination_album)");
        if (!$result) {
          pg_query($database, "rollback");
          continue;
        }
        pg_query($database, "commit");
      }
    }
  }
}

site_epilog($database);
header("location: $return_path");

?>
