<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  /* 
     This file contains configuration defaults.  Do NOT modify this 
     file; It will be automatically overwritten on future upgrades.
     Instead, please add configuration entries to 

 		src/include/config_site.php 
  */

// The PO site url
$site_url = "http://localhost/po";
// This appears in the titlebar on every page.
$site_title = "My Photo Organizer";

// Default sorting order
$default_order_by = 7;

/* Database connection details */

// Use a local database via UNIX socket (fast and secure, default)
$db_dsn = "dbname=po_db user=po_user password=po_password";

// Use a local database via IP (slower)
// $db_dsn = "host=127.0.0.1 port=5432 dbname=po_db user=po_user password=po_password";

// Use an external database via IP 
// $db_dsn = "host=218.61.15.251 port=5432 dbname=po_db user=po_user password=po_password";

/* End Database details */

// content based image retrieval server connection details:
$cbir_host = "";
$cbir_port = "";

// Use output compression?
$compress_pages = true;

// Allow bulk uploads from local filesystem?
$local_bulk_upload = false;

// absolute path to your image repository which
// is used to store all your image files
$image_repository_path = "/export/po_dev_image_repository";

// absolute path to your temporary directory which
// is used to store printed files while they are converted
// and to perform bulk uploads
$tmp_volume_path = "/tmp";

// ImageMagick convert tool
$sys_convert = "/usr/bin/convert";

// ImageMagick composite tool
$sys_composite = "/usr/bin/composite";

// Dave Coffin's raw image decoder
$sys_dcraw = "/usr/local/bin/dcraw";

// exiftool utility
$sys_exiftool = "/usr/bin/exiftool";

/* Raw decoders, in order of prescedence */
$raw_decoder = "dcraw,exiftool"; 

// PS2PDF - converts PS documents into PDF ones
$sys_ps2pdf  = "/usr/bin/ps2pdf";

// gtar - must support the -z and -j options
$sys_tar = "/bin/tar";

// unzip
$sys_unzip = "/usr/bin/unzip";

// The path to the current theme - relative to the PO installation directory
$theme = "themes/aqua";

// The name of the cookie which stores the user's session id
$po_cookie = "po_session_id";

// The size of the medium sized image
$image_max_size = 700;

// Thumbnail image size, smaller than the cell size
$thumb_max_size = 170;

// The size of the slide cell
$cell_size = 200;

// Page width
$page_width = "92%";

// Default paper and label
$default_paper = 13;
$default_label = 17;

// Default number of columns
$default_num_of_columns             = 4;
$default_num_of_rows_in_slide_view  = 4;
$default_num_of_rows_in_list_view   = 20;
$maximum_num_of_rows_in_slide_view  = 20;
$maximum_num_of_rows_in_list_view   = 100;

// Default popup tooltip parameters
$default_popup_enable               = "f";
$default_popup_delay                = 100;
$default_enable_stemming            = "f";

// Default ImageMagick options
$default_im_preview_quality         = 85;
$default_im_preview_color_space     = "RGB";
$default_im_preview_gamma           = 1;
$default_im_preview_sharpen_radius  = 0.5;
$default_im_preview_sharpen_sigma   = 0.5;
$default_im_preview_sharpen_amount  = 1.4;
$default_im_preview_sharpen_threshold = 0.05;
$default_im_preview_border_width    = 0;
$default_im_preview_border_height   = 0;
$default_im_preview_border_color    = "000000";

$default_im_thumb_quality           = 85;
$default_im_thumb_color_space       = "RGB";
$default_im_thumb_gamma             = 1;
$default_im_thumb_sharpen_radius    = 0.5;
$default_im_thumb_sharpen_sigma     = 0.5;
$default_im_thumb_sharpen_amount    = 2.2;
$default_im_thumb_sharpen_threshold = 0.00;
$default_im_thumb_border_width      = 0;
$default_im_thumb_border_height     = 0;
$default_im_thumb_border_color      = "000000";


// Default ImageMagick composite options
$default_im_watermark_brightness    = 0;
$default_im_watermark_location      = "center";

// Default DCRAW options
$default_dcraw_gamma                = 0.6;
$default_dcraw_brightness           = 1.0;
$default_dcraw_white_balanace       = "camera";
$default_dcraw_bitdepth             = 24;

// You might want to add more forbidden keywords
$forbidden_keywords = array("a", "b", "c", "d", "e", "f", "g", "h",
                             "i", "j", "k", "l", "m", "n",  "o", "p",
                             "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
                             "on", "in", "the", "of", "to", "at", "an", "as");

/* Default error reporting level */
error_reporting(E_ALL ^ E_NOTICE);

/* Do NOT remove the below lines */
$install_enabled=0;
include_once "config_site.php"

?>
