<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";

$algorithm_list = array();
$algorithm_counter = 0;

function createXMPFile() {
  global $sys_convert;

  /* build color palette */
  $width  = $_REQUEST['width'];
  $height = $_REQUEST['height'];
  $num_of_colors = 0;
  $color_palette = array();
  for ($j = 0; $j < $height; $j++) {
    for ($i = 0; $i < $width; $i++) {
      $index = $j * $width + $i;
      $key = str_pad($_REQUEST['px'.$index], 6, "0", STR_PAD_LEFT);
      $found = false;
      for ($iterator = 0; $iterator < $num_of_colors; $iterator++)
        if ($color_palette[$iterator] == $key) {
          $found = true;
          break;
        }

      if (!$found) {
        $color_palette[$num_of_colors] = $key;
        $num_of_colors++;
      }
    }
  }

  /* build the XPM file */
  $file_body = "/* XPM */\n";
  $file_body = $file_body . "static char *image-up[] = {\n";
  $file_body = $file_body . "/* width  height   num_of_colors   chars_per_pixel */\n";
  $file_body = $file_body . "\"  $width $height  $num_of_colors  2\",\n";

  $file_body = $file_body . "/* colors */\n";
  for ($c = 0; $c < $num_of_colors; $c++) {
    $file_body = $file_body . "\"".str_pad($c, 2, "0", STR_PAD_LEFT)." c #".$color_palette[$c]."\",\n";
  }

  $file_body = $file_body . "/* pixels */\n";

  for ($j = 0; $j < $height; $j++) {
    $file_body = $file_body . "\"";
    for ($i = 0; $i < $width; $i++) {
      $index = $j * $width + $i;
      $key = str_pad($_REQUEST['px'.$index], 6, "0", STR_PAD_LEFT);

      for ($c = 0; $c < $num_of_colors; $c++) {
        if ($key == $color_palette[$c])
          $file_body = $file_body . str_pad($c, 2, "0", STR_PAD_LEFT);
      }
    }
    if ($j == ($height - 1))
      $file_body = $file_body . "\"\n};\n";
    else
      $file_body = $file_body . "\",\n";
  }

  /* write the temporary file */
  $temp_file_name = tempnam($temporary_directory, "po.layout.search");

  $fd = fopen($temp_file_name, "w+");
  fwrite($fd, $file_body);
  fclose($fd);

  $temp_file_name_xmp = $temp_file_name  . ".xpm";
  $temp_file_name_png = $temp_file_name  . ".png";
  rename($temp_file_name, $temp_file_name_xmp);

  system("$sys_convert $temp_file_name_xmp $temp_file_name_png",  $retval_convert);

  unlink($temp_file_name_xmp);
  return $temp_file_name_png;
}

function display_xml($xml_code) {
  $xml_code = ereg_replace("<", "&lt;", $xml_code);
  $xml_code = ereg_replace(">", "&gt;", $xml_code);
  $xml_code = ereg_replace("\"", "&quot;", $xml_code);
  $xml_code = ereg_replace("\n", "<br/>\n", $xml_code);
  print $xml_code;
}

function startElement($parser, $name, $attribs) {
  global $photo_id_list;
  global $photo_id_counter;

  switch ($name) {
  case "QUERY":
    break;
  case "ALGORITHM":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "NAME":
          $current_folder = $value;
          break;
        case "VERSION":
          $current_folder = $value;
          break;
        case "REPLY":
          $current_folder = $value;
          break;
        }
      }
    }
    break;
  case "MEDIA":
    $image_data['folder'] = $current_folder;
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $photo_id_list[$photo_id_counter] = "$value";
          $photo_id_counter++;
          break;
        case "SRC":
          $image_data['src'] = "$value";
          break;
        case "SIMILARITY":
          $image_data['similarity'] = $value;
          break;
        case "REPLY":
          $image_data['reply'] = $value;
          break;
        case "TIME":
          $image_data['time'] = $value;
          break;
        }
      }
    }
    break;
  }
}

function endElement($parser, $name) {
}

function argon_query($identifier, $cbir_host, $cbir_port,
                     $index_algorithm, $search_algorithm, $type,
                     $limit, $offset,
                     $photo_id, $photo_path) {

  $verbose = TRUE;

  if (!$cbir_host || !$cbir_port || !$photo_path)
    return;

  $socket = socket_create (AF_INET, SOCK_STREAM, 0);
  if ($socket == FALSE) {
    echo "socket_create() failed: reason: " . socket_strerror ($socket) . "<br/>\n";
    return;
  }

  $result = socket_connect ($socket, $cbir_host, $cbir_port);
  if ($result == FALSE) {
    echo "socket_connect() failed.<br/>\nReason: ($result) " . socket_strerror($result) . "<br/>\n";
    return;
  }

  $index_algorithm_string = substr($index_algorithm, 0, strrpos($index_algorithm, ":"));
  $index_algorithm_version = substr($index_algorithm, strrpos($index_algorithm, ":") + 1);

  $search_algorithm_string = substr($search_algorithm, 0, strrpos($search_algorithm, ":"));
  $search_algorithm_version = substr($search_algorithm, strrpos($search_algorithm, ":") + 1);

  $submit = create_query_header($identifier, $type);
  $submit = $submit . create_index_algorithm_header($index_algorithm_string, $index_algorithm_version);
  $submit = $submit . create_search_algorithm_header($search_algorithm_string, $search_algorithm_version, $limit, $offset);
  $submit = $submit . create_body($photo_id, $photo_path);
  $submit = $submit . create_search_algorithm_footer();
  $submit = $submit . create_index_algorithm_footer();
  $submit = $submit . create_query_footer();

  socket_write ($socket, $submit, strlen($submit));

  if ($verbose) {
    print "<h2>Request</h2>";
    print "<p><code>\n";
    display_xml($submit);
    print "</code></p>\n";
  }

  $xml_parser = xml_parser_create();
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
  xml_set_element_handler($xml_parser, "startElement", "endElement");

  if ($verbose) {
    print "<h2>Reply</h2>";
    print "<p><code>\n";
  }

  error_reporting(0);
  do {
    if (FALSE === ($out = socket_read ($socket, 2048, PHP_NORMAL_READ))) {
      break;
    }

    if (!xml_parse($xml_parser, $out)) {
      print "<font color=\"red\">XML ERROR -";
      print " error code:" . xml_get_error_code($xml_parser);
      print " error string:" . xml_error_string(xml_get_error_code($xml_parser));
      print " error line:" . xml_get_current_line_number($xml_parser);
      print "</font>\n</p>\n";
      print "<p>";
      display_xml($out);
      print "</p>\n";
      xml_parser_free($xml_parser);


      xml_parser_free($xml_parser);
      socket_close($socket);
      error_reporting(1);
      exit;
    }

    if ($verbose) {
      display_xml($out);
    }
  } while (true);

  if ($verbose) {
    print"</code></p>\n";
  }

  xml_parser_free($xml_parser);
  socket_close($socket);
  error_reporting(1);
}


function display_effective_content_search($session_id, $photo_id) {
  global $theme;
  global $cbir_host;
  global $cbir_port;

  if (($cbir_host == "") || ($cbir_port == ""))
    return FALSE;

  print "<form method=\"post\" action=\"search.image.php\">\n";
  print "<table><tr><td align=\"left\" valign=\"middle\">";
  print "<input type=\"image\" src=\"$theme/button.search.gif\" border=\"0\" value=\"Search\"/>\n";
  print "</td><td align=\"left\" valign=\"middle\">";
  print "<input type=\"hidden\" name=\"photo_id\" value=\"$photo_id\"/>\n";
  print "<select name=\"type\">";
  print "<option value=\"layout\">for photos with similar layout";
  print "<option value=\"color\">for photos with similar colors";
  print "</select>";
  print "</td></tr></table>";
  print "</form>\n";
}

function display_content_submit($type) {
  global $theme;
  global $cbir_host;
  global $cbir_port;

  if (($cbir_host == "") || ($cbir_port == ""))
    return FALSE;

  print "<table>\n<tr>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"".$type."\">";
  print "<option value=\"layout\">Index image layout";
  print "<option value=\"color\">Index image colors";
  print "</select>";
  print "</td>\n</tr>\n</table>\n";
}


function submit_photo($database, $photo_id, $session_id, $index_algorithm) {
  global $site_url;
  global $cbir_host;
  global $cbir_port;
  global $image_repository_path;

  $verbose = TRUE;

  if (($cbir_host == "") || ($cbir_port == ""))
    return FALSE;

  error_reporting(0);
  $socket = socket_create (AF_INET, SOCK_STREAM, 0);
  if ($socket == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $result = socket_connect ($socket, $cbir_host, $cbir_port);
  if ($result == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $index_algorithm_string = substr($index_algorithm, 0, strrpos($index_algorithm, ":"));
  $index_algorithm_version = substr($index_algorithm, strrpos($index_algorithm, ":") + 1);

  $submit =           "<?xml version=\"1.0\" standalone=\"yes\" ?>\n";
  $submit = $submit . "<submit id=\"$session_id\">\n";
  $submit = $submit . "<index_algorithm name=\"$index_algorithm_string\" version=\"$index_algorithm_version\">\n";
  $submit = $submit . "<media id=\"$photo_id\" src=\"$site_url/image.display.php?image=$photo_id\" />\n";
  $submit = $submit . "</index_algorithm>\n";
  $submit = $submit . "</submit>\n";

  if ($verbose) {
    print "<h2>Request</h2>";
    print "<p><code>\n";
    display_xml($submit);
    print "</code></p>\n";
  }

  socket_write ($socket, $submit, strlen($submit));

  if ($verbose) {
    print "<h2>Reply</h2>";
    print "<p><code>\n";
  }

  do {
    if (FALSE === ($out = socket_read ($socket, 2048, PHP_NORMAL_READ))) {
      break;
    }
    if ($verbose) {
      display_xml($out);
    }
  } while (true);

  if ($verbose) {
    print"</code></p>\n";
  }

  socket_close($socket);
  error_reporting(1);
  return TRUE;
}

function audit_photo($database, $photo_id, $session_id) {
  global $site_url;
  global $cbir_host;
  global $cbir_port;
  global $image_repository_path;

  $verbose = TRUE;

  if (($cbir_host == "") || ($cbir_port == ""))
    return FALSE;

  error_reporting(0);
  $socket = socket_create (AF_INET, SOCK_STREAM, 0);
  if ($socket == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $result = socket_connect ($socket, $cbir_host, $cbir_port);
  if ($result == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $index_algorithm_string = substr($index_algorithm, 0, strrpos($index_algorithm, ":"));
  $index_algorithm_version = substr($index_algorithm, strrpos($index_algorithm, ":") + 1);

  $audit =           "<?xml version=\"1.0\" standalone=\"yes\" ?>\n";
  $audit = $audit . "<audit id=\"$session_id\">\n";
  $audit = $audit . "<vacuum>\n";
  if ($photo_id == "all")
    $audit = $audit . "<media id=\"$photo_id\" src=\"$photo_id\" />\n";
  else
    $audit = $audit . "<media id=\"$photo_id\" src=\"$site_url/image.display.php?image=$photo_id\" />\n";
  $audit = $audit . "</vacuum>\n";
  $audit = $audit . "</audit>\n";

  if ($verbose) {
    print "<h2>Request</h2>";
    print "<p><code>\n";
    display_xml($audit);
    print "</code></p>\n";
  }

  socket_write ($socket, $audit, strlen($audit));

  if ($verbose) {
    print "<h2>Reply</h2>";
    print "<p><code>\n";
  }

  do {
    if (FALSE === ($out = socket_read ($socket, 2048, PHP_NORMAL_READ))) {
      break;
    }
    if ($verbose) {
      display_xml($out);
    }
  } while (true);

  if ($verbose) {
    print"</code></p>\n";
  }

  socket_close($socket);
  error_reporting(1);
  return TRUE;
}


function startAlgorithmElement($parser, $name, $attribs) {
  global $algorithm_list;
  global $algorithm_counter;
  switch ($name) {
  case "QUERY":
    break;
  case "INDEX_ALGORITHM_LIST":
  case "SEARCH_ALGORITHM_LIST":
    $algorithm_list = array();
    $algorithm_counter = 0;
    break;
  case "INDEX_ALGORITHM":
  case "SEARCH_ALGORITHM":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "NAME":
          $algorithm_list[$algorithm_counter]['name'] = $value;
          break;
        case "VERSION":
          $algorithm_list[$algorithm_counter]['version'] = $value;
          break;
        case "COEF":
          $algorithm_list[$algorithm_counter]['coef'] = $value;
          break;
        case "DESC":
          $algorithm_list[$algorithm_counter]['desc'] = $value;
          break;
        }
      }
    }
    break;
  }
}

function endAlgorithmElement($parser, $name) {
  global $algorithm_counter;

  switch ($name) {
  case "INDEX_ALGORITHM":
  case "SEARCH_ALGORITHM":
    $algorithm_counter++;
    break;
  }
}

function retrieve_argon_algorithm_list($identifier, $cbir_host, $cbir_port, $type) {
  $verbose = TRUE;
  /* $type = ["index", "search"]*/
  if (($cbir_host == "") || ($cbir_port == ""))
    return FALSE;

  error_reporting(0);
  $socket = socket_create (AF_INET, SOCK_STREAM, 0);
  if ($socket == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $result = socket_connect ($socket, $cbir_host, $cbir_port);
  if ($result == FALSE) {
    error_reporting(1);
    return FALSE;
  }

  $query =           "<?xml version=\"1.0\" standalone=\"yes\" ?>\n";
  $query = $query . "<query id=\"$identifier\">\n";
  $query = $query . "<".$type."_algorithm_list />\n";
  $query = $query . "</query>\n";

  socket_write ($socket, $query, strlen($query));

  if ($verbose) {
    print "<h2>Request</h2>";
    print "<p><code>\n";
    display_xml($submit);
    print "</code></p>\n";
  }

  $xml_parser = xml_parser_create();
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
  xml_set_element_handler($xml_parser, "startAlgorithmElement", "endAlgorithmElement");

  if ($verbose) {
    print "<h2>Reply</h2>";
    print "<p><code>\n";
  }

  do {
    if (FALSE === ($out = socket_read ($socket, 2048, PHP_NORMAL_READ))) {
      break;
    }

    if (!xml_parse($xml_parser, $out)) {
      print sprintf("<font color=red>%s, XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
                    $out,
                    xml_get_error_code($xml_parser),
                    xml_error_string(xml_get_error_code($xml_parser)),
                    xml_get_current_line_number($xml_parser));
      xml_parser_free($xml_parser);
      socket_close($socket);
      error_reporting(1);
      exit;
     }

    if ($verbose) {
      display_xml($out);
    }
  } while (true);

  if ($verbose) {
    print"</code></p>\n";
  }

  xml_parser_free($xml_parser);
  socket_close($socket);
  error_reporting(1);
  return TRUE;
}

function create_argon_algorithm_combo($item, $algorithm_list, $value) {

  $combo = "<select name=\"".$item."\">";

  foreach ($algorithm_list as $element) {
    $combined_name = $element['name'].":".$element['version'];
    $combo = $combo."<option value=\"".$combined_name."\"";

    if ($element['desc'] || $element['version']) {
      $combo = $combo." title=\"".$element['desc']." version: ".$element['version'] ."\"";
    }

    if ($value == $combined_name)
      $combo = $combo." selected ";

    $combo = $combo.">".$element['name'] . " " . $element['version'];
  }

  $combo = $combo."</select>";
  return $combo;
}

function create_submit_header($id) {
  $header = "<?xml version=\"1.0\" standalone=\"yes\" ?>\n";
  $header = $header . "<submit id=\"$id\">\n";
  return $header;
}

function create_query_header($id, $type) {
  $header = "<?xml version=\"1.0\" standalone=\"yes\" ?>\n";
  $header = $header . "<query id=\"$id\" type=\"$type\">\n";
  return $header;
}

function create_search_algorithm_header($algorithm, $version, $limit, $offset) {
  $header = "<search_algorithm name=\"$algorithm\" version=\"$version\" ";
  if ($limit)
    $header = $header . " limit=\"$limit\" ";
  if ($offset)
    $header = $header . " offset=\"$offset\" ";
  $header = $header . ">\n";
  return $header;
}

function create_index_algorithm_header($algorithm, $version) {
  $header = "<index_algorithm name=\"$algorithm\" version=\"$version\">\n";
  return $header;
}

function create_body($photo_id, $photo_id_src) {
  return "<media id=\"$photo_id\" src=\"$photo_id_src\" />\n";
}

function create_index_algorithm_footer() {
  return "</index_algorithm>\n";
}

function create_search_algorithm_footer() {
  return "</search_algorithm>\n";
}

function create_submit_footer() {
  return "</submit>\n";
}

function create_query_footer() {
  return "</query>\n\n";
}




?>
