<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/contacts.php";
include_once "include/site.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['client']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$transaction_id = pg_escape_string($_REQUEST['order']);

$total_price = 0;
$currency = "";

$photos_in_order = pg_query($database, "
  select shop_order.identifier,
         (select photo from photo_item where photo_item.identifier=shop_order.item) as photo,
          pieces,
         (select title from photo, photo_item where photo.identifier=photo_item.photo and photo_item.identifier=shop_order.item),
         (select caption from shop_category, shop_item, photo_item where shop_category.identifier=shop_item.category and photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as category,
         (select description from shop_item, photo_item where photo_item.shop_item=shop_item.identifier and photo_item.identifier=shop_order.item) as description,
         (select alpha_code from photo_item, currency where photo_item.currency=currency.identifier and photo_item.identifier=shop_order.item) as currency,
         (select price from photo_item where photo_item.identifier=shop_order.item) as price,
         (select comment from photo_item where photo_item.identifier=shop_order.item) as comment,
         client, first_name, last_name,
         shop_transaction.identifier, shop_transaction.remark, shop_transaction.status,
         download_counter, download_expiry_date
    from shop_order, users, shop_transaction
   where shop_order.client=users.identifier
     and shop_transaction.identifier=shop_order.transaction
     and shop_transaction.identifier=$transaction_id");

if (pg_num_rows($photos_in_order) == 0) {
  site_header($page_width, "Store : Order");
  site_navigator(8);
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.datebook.php?selector=2\">My Date Book</a> : <font color=\"red\">Unknown order identifier</font>", "");
  site_footer($database);
  site_epilog($database);
  exit();
}

$order_kind = pg_fetch_row($photos_in_order, 0);
if ($order_kind[14] == 1) {
  $order_kind = "<a href=\"my.datebook.php?selector=2\">Pending Orders</a>";
}
else {
  $order_kind = "<a href=\"my.datebook.php?selector=3\">Shipments</a>";
}

site_header($page_width, "Store : Order");
site_navigator(8);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.datebook.php?selector=2\">My Date Book</a> : $order_kind : Order $transaction_id", "");
print "&nbsp;<br/>\n";


if ($po_user['type'] > $user_type['client']) {
  print "<form method=\"post\" action=\"shop.order.edit.php\">";
  print "<input type=\"hidden\" name=\"order\" value=\"$transaction_id\"/>";
}

$previous_transaction_id = 0;
$number_of_items = pg_num_rows($photos_in_order);
for ($item = 0; $item < $number_of_items; $item++) {
  $photo = pg_fetch_row($photos_in_order, $item);

  if ($photo[12] != $previous_transaction_id) {
    $previous_transaction_id = $photo[12];
    $display_transaction_id = str_pad($photo[12], 6, "0", STR_PAD_LEFT);

    if ($item > 0) {
      print "<tr>";
      print "<td align=\"right\" bgcolor=\"$color[table_body]\"  colspan=\"3\"><b>Total:</b> </td>";
      print "<td align=\"right\" bgcolor=\"$color[table_body]\" ><b>$total_items</b></td>";
      print "<td align=\"right\" bgcolor=\"$color[table_body]\" ><b>$total_price $currency</b></td>";
      print "</tr>";
      print "</table>";
      print "&nbsp;<br/>\n";
    }
    else {
      print "<table>\n";
      print "<tr><td >Order&nbsp;&nbsp;</td><td ><b>$display_transaction_id</b></td></tr>";
      print "<tr><td >Client&nbsp;&nbsp;</td><td ><a href=\"user.php?user=$photo[9]\">$photo[10], $photo[11]</a></td></tr>";
      if ($photo[13]) {
        print "<tr><td >Message&nbsp;&nbsp;</td><td >$photo[13]</td></tr>";
      }
      print "<tr><td >Status&nbsp;&nbsp;</td><td >";
      if ($po_user['type'] > $user_type['client']) {
        $all_transaction_states = pg_query($database, "select identifier, value from shop_transaction_status order by identifier");
        display_combo("status", $all_transaction_states, $photo[14], "", 1);
      }
      else {
        $transaction_state = pg_fetch_row(pg_query($database, "select value from shop_transaction_status where identifier=$photo[14]"));
        print $transaction_state[0];
      }
      print "</td></tr>";
      print "</table>\n";
      print "&nbsp;<br/>\n";
    }

    $total_price = 0;
    $total_items = 0;

    print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\"><tr>\n";
    print "<td bgcolor=\"$color[table_top]\" colspan=\"9\"><font class=\"tabletop\">Item List</font></td>";
    print "</tr><tr>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"20%\">Title</td>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"10%\">Category</td>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"10%\">Item</td>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"20%\">Details</td>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"8%\">Download Counter</td>";
    print "<td align=\"left\"  bgcolor=\"$color[table_header]\"  width=\"8%\">Download Expiry Date</td>";
    print "<td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"8%\">Price</td>";
    print "<td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"8%\">Pieces</td>";
    print "<td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"8%\">Subtotal</td>";
    print "</tr><tr>";
  }

  $on_mouse_over ="t_w=10; ttWidth=10; return escape('<img src=image.display.php?image=$photo[1]&size=1 border=0')";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
  if (!$photo[3])
    $photo[3] = "No Title";
  print "<a href=\"photo.php?photo=$photo[1]&detail_info=8\" onmouseover=\"$on_mouse_over\">$photo[3]</a></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" nowrap>$photo[4]</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" nowrap>$photo[5]</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$photo[8]</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
  if ($po_user['type'] > $user_type['client']) {
    print "<select name=\"dcount".$photo[0]."\">";
    print "<option value=\"unlimited\"";
    if ($photo[15] == 3000) {
      print " selected ";
    }
    print ">Unlimited";
    for ($pcs = 0; $pcs < 101; $pcs++) {
      print "<option value=\"$pcs\"";
      if ($pcs == $photo[15]) {
        print " selected ";
      }
      print ">$pcs";
    }
    print "</select>";
  }
  else {
    print ($photo[15] == 3000) ? "Unlimited" : $photo[15];
  }
  print "</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" nowrap>\n";
  if ($po_user['type'] > $user_type['client']) {
    display_date_input_form("expiry_timestamp".$photo[0], $photo[16]);
  }
  else {
    print generate_date_html($photo[16], 'date', 1);
  }
  print "</td>\n";
  print "<td align=\"right\" bgcolor=\"$color[table_body]\" >$photo[7] $photo[6]</td>";
  print "<td align=\"right\" bgcolor=\"$color[table_body]\" >$photo[2]</td>";
  $subtotal = $photo[2] * $photo[7];
  print "<td align=\"right\" bgcolor=\"$color[table_body]\" >$subtotal $photo[6]</td>";
  print "</tr>\n";
  $currency = $photo[6];
  $total_price += $subtotal;
  $total_items += $photo[2];
}

print "<tr>";
print "<td align=\"right\" bgcolor=\"$color[table_body]\"  colspan=\"7\"><b>Total:</b> </td>";
print "<td align=\"right\" bgcolor=\"$color[table_body]\" ><b>$total_items</b></td>";
print "<td align=\"right\" bgcolor=\"$color[table_body]\" ><b>$total_price $currency</b></td>";
print "</tr>";
print "</table>";
print "&nbsp;<br/>\n";

if ($po_user['type'] > $user_type['client']) {
  print "<center>";
  print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" alt=\"Save Changes\"/>\n";
  print "</center>";
  print "</form>";
}
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
site_footer($database);
site_epilog($database);
?>
